#ifndef CLASS_SPECIFICATION
#define CLASS_SPECIFICATION
#include <vector>
#include <MObject.h>

class ClassSpecificationWidget;
class ClassSpecificationLoadHandler;
class MemberVariableSpecification;
class MemberFunctionSpecification;
class GenericProductionContext;
class InteractionSpecification;
class ClassSpecification;


class ClassSpecification: public MObject
{
     public:
     
		ClassSpecification();
		~ClassSpecification();
		
		const char * get_key() const;

		bool hasAncestor() const;
		
		bool permanent;
		bool abstract;
		bool mobject_child;
		bool has_virtual_functions;
		
		//  Later Permanent Reference
		
		ClassSpecification * ancestor_class;
		
		std::vector <MemberVariableSpecification *> my_variable_specifications; // link_id = 10001

		unsigned int object_class_id;
		
		static const unsigned int class_id = 100007;
};


#endif
