#include <MObject_serialization.hh>

// MObject

namespace boost {
namespace serialization {

template<class Archive>
void save(Archive & ar, const MObject & m, unsigned int version)
{  
	unsigned int tmp;
	
	// +++ Later we can maybe do that with const static integers as link ids

	tmp = 1002;
	ar & make_nvp("link_id",tmp);
    ar & BOOST_SERIALIZATION_NVP(m.instance_id);
    tmp = 1003;
    ar & make_nvp("link_id",tmp);
    ar & BOOST_SERIALIZATION_NVP(m.specification_version);
    tmp = 1004;
    ar & make_nvp("link_id",tmp);
	ar & BOOST_SERIALIZATION_NVP(m.instance_version);
	
	tmp = 100;
	ar & make_nvp("link_id",tmp);
}

template<class Archive>
void load(Archive & ar, MObject & m, unsigned int version)
{
	unsigned int tmp;
	
	while (true)
	{
		ar & make_nvp("link_id",tmp);
	
		switch (tmp)	
		{
			case 100:
			{
				return;
			}; break;
			
			case 1002:
			{
				ar & BOOST_SERIALIZATION_NVP(m.instance_id);
			}; break;

			case 1003:
			{
				ar & BOOST_SERIALIZATION_NVP(m.specification_version);
			}; break;
			
			case 1004:
			{
				ar & BOOST_SERIALIZATION_NVP(m.instance_version);
			}; break;			
			
		}
	}
}

} // namespace serialization
} // namespace boost


const char * MObject::get_key()const
{
	const boost::serialization::extended_type_info *eti
	= boost::serialization::type_info_implementation<MObject>::type::get_instance();
	
	return eti->get_key();         
}


BOOST_CLASS_EXPORT(MObject)
