// INDEPENDENT TEST

#include <MObject.h>
#include <MObject_serialization.hh>
#include <MemberVariableSpecification.h>
#include <MemberVariableSpecification_serialization.hh>
#include <fstream>

#include <boost/archive/xml_oarchive.hpp>
#include <boost/archive/xml_iarchive.hpp>

#include <boost/serialization/nvp.hpp>

int main(int argc, char* argv[])
{
	std::ofstream log("log.log");
		
	{
		MObject * base_object = new MemberVariableSpecification();
		
		std::ofstream oxmlf("test.archive");

			
		boost::archive::xml_oarchive oxml(oxmlf);
		
		try
		{
			oxml &  boost::serialization::make_nvp("test", base_object);
		}
	
		catch( boost::archive::archive_exception & x)
	    {
	        log << "Error occured while trying to save: " << x.what() << std::endl;
	    }
	
	}

	{
		log << "Trying to load: " ;
		
		MObject * generic_pointer;
		
		std::ifstream ixmlf("test.archive");
	
		boost::archive::xml_iarchive ixml(ixmlf);

		ixml & boost::serialization::make_nvp("test",generic_pointer);
		
		if (dynamic_cast <MemberVariableSpecification *> (generic_pointer) == NULL)
		{
			log << "Polymorphism failed." << std::endl;
		}
		else
		{
			log << "Polymorphism was successfull." << std::endl;	
		}
	}

	return 0;

}
